require 'rainbow'
require 'logger'

namespace :import do

  desc "Create Subject relations based on its metadata"
  task :subjects, [:log] => [:environment] do |t, args|
  
  logger = Logger.new(STDOUT)
  educational_relations = []

    EducationalStage.all.each do |educational|
      logger.info("Creating relations of #{educational.name}")

      if tag_exists?(educational.name)
        tag = Tag.find_by_name(educational.name)
      else
        tag = Tag.create(name: educational.name)
      end

      tag.taggings.each do |tagging|
          logger.info("#{tagging.tag_id} #{tagging.taggable_id} #{tagging.taggable_type}")
          unless educational_relation_exists?(tagging.tag_id, tagging.taggable_id, tagging.taggable_type)
            educational_relation = EducationalRelation.new(educational_stage_id: tagging.tag_id, educationable_id: tagging.taggable_id, educationable_type: tagging.taggable_type)
            educational_relations << educational_relation
          end
      end

    end
  

    EducationalRelation.import educational_relations  
  end

  private

  def tag_exists? (name)
    Tag.where(name: name).exists?
  end

  def educational_relation_exists? (educational_id, educationable_id, educationable_type)
    Tagging.where(tag_id: educational_id, taggable_id: educationable_id, taggable_type: educationable_type).exists?
  end

end
