require 'rainbow'
require 'logger'

namespace :import do

  desc "Create Subject relations based on its metadata"
  task :subjects, [:log] => [:environment] do |t, args|
  
  logger = Logger.new(STDOUT)
  subject_relations = []

    Subject.all.each do |subject|
      logger.info("Creating relations of #{subject.name}")

      if tag_exists?(subject.name)
        tag = Tag.find_by_name(subject.name)
      else
        tag = Tag.create(name: subject.name)
      end

      tag.taggings.each do |tagging|
          logger.info("#{tagging.tag_id} #{tagging.taggable_id} #{tagging.taggable_type}")
          subject_relation = SubjectRelation.new(subject_id: tagging.tag_id, subjectable_id: tagging.taggable_id, subjectable_type: tagging.taggable_type)
          subject_relations << subject_relation
      end

    end
  

    SubjectRelation.import subject_relations  
  end

  private

  def tag_exists? (name)
    Tag.where(name: name).exists?
  end

end
